-- DDL
DROP TABLE IF EXISTS proposals;
DROP TABLE IF EXISTS orders;
DROP TABLE IF EXISTS incidents;
DROP TABLE IF EXISTS users;
DROP TABLE IF EXISTS roles ;
DROP TABLE IF EXISTS vendor_status ;
DROP TABLE IF EXISTS CAR_MODELS ;
DROP TABLE IF EXISTS CAR_BRANDS ;

CREATE TABLE IF NOT EXISTS  ROLES
(
    ID    INT PRIMARY KEY,
    ROLE_NAME  VARCHAR(10) NOT NULL
);

CREATE TABLE IF NOT EXISTS  VENDOR_STATUS
(
    ID    INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    VENDOR_ID  INT NOT NULL,
    STATUS VARCHAR(20) NOT NULL
);

CREATE TABLE IF NOT EXISTS INCIDENTS
(
    ID          INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    USER_ID     INT NOT NULL,
    DESCRIPTION VARCHAR(200) NOT NULL,
    CAR_BRAND   VARCHAR(50),
    CAR_MODEL   VARCHAR(50),
    CAR_WEIGHT  INT,
    LOC_FROM VARCHAR(50),
    LOC_TO   VARCHAR(50),
    IN_ORDER BOOLEAN NOT NULL
);

CREATE TABLE IF NOT EXISTS USERS
(
    ID       INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    NAME     VARCHAR(20),
    EMAIL    VARCHAR(50) NOT NULL,
    PASSWORD VARCHAR(100) NOT NULL,
    PHONE    VARCHAR(20) NOT NULL,
    ROLE_ID     INT NOT NULL
);

CREATE TABLE IF NOT EXISTS PROPOSALS
(
    ID          INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    VENDOR_ID     INT NOT NULL,
    INCIDENT_ID INT NOT NULL,
    PRICE    FLOAT NOT NULL
);

CREATE TABLE IF NOT EXISTS ORDERS
(
    ID       INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    DATE     TIMESTAMP WITH TIME ZONE NOT NULL,
    VENDOR_ID   INT NOT NULL,
    INCIDENT_ID INT NOT NULL,
    PRICE    FLOAT NOT NULL,
    STATUS   VARCHAR(50) NOT NULL
);
CREATE TABLE CAR_BRANDS
(
    ID          INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    BRAND_NAME  VARCHAR(50) NOT NULL
);

CREATE TABLE CAR_MODELS
(
    ID           INT PRIMARY KEY GENERATED ALWAYS AS IDENTITY,
    BRAND        INT NOT NULL,
    MODEL_NAME   VARCHAR(50) NOT NULL,
    );

COMMIT;